#pragma once

#include <QObject>

namespace MellowPlayer::Domain
{
    class SettingKey : public QObject
    {
        Q_OBJECT
    public:
        enum Keys
        {
            MAIN_CONFIRM_EXIT,
            MAIN_CLOSE_TO_TRAY,
            MAIN_SHOW_TRAY_ICON,
            MAIN_CHECK_FOR_UPDATES,
            MAIN_UPDATE_CHANNEL,
            MAIN_PLAYBACK_REQUIRES_USER_GESTURE,
            APPEARANCE_THEME,
            APPEARANCE_ACCENT,
            APPEARANCE_BACKGROUND,
            APPEARANCE_FOREGROUND,
            APPEARANCE_PRIMARY_BACKGROUND,
            APPEARANCE_PRIMARY_FOREGROUND,
            APPEARANCE_SECONDARY_BACKGROUND,
            APPEARANCE_SECONDARY_FOREGROUND,
            NOTIFICATIONS_ENABLED,
            NOTIFICATIONS_NEW_SONG,
            NOTIFICATIONS_PAUSED,
            NOTIFICATIONS_RESUMED,
            SHORTCUTS_PLAY,
            SHORTCUTS_NEXT,
            SHORTCUTS_PREVIOUS,
            SHORTCUTS_FAVORITE,
            SHORTCUTS_RESTORE_WINDOW,
            SHORTCUTS_RELOAD,
            SHORTCUTS_SELECT_SERVICE,
            SHORTCUTS_SELECT_NEXT_SERVICE,
            SHORTCUTS_SELECT_PREVIOUS_SERVICE,
            SHORTCUTS_NOTIFICATIONS,
            SHORTCUTS_LISTENING_HISTORY,
            SHORTCUTS_SETTINGS,
            SHORTCUTS_CREATE_PLUGIN,
            SHORTCUTS_REPORT_ISSUE,
            SHORTCUTS_CHECK_FOR_UPDATE,
            SHORTCUTS_ABOUT,
            SHORTCUTS_QUIT,
            PRIVACY_ENABLE_LISTENING_HISTORY,
            PRIVACY_LISTENING_HISTORY_LIMIT,
            PRIVACY_USER_AGENT,
            PRIVATE_SHOW_CLOSE_TO_TRAY_MESSAGE,
            PRIVATE_CURRENT_SERVICE,
            PRIVATE_WINDOW_WIDTH,
            PRIVATE_WINDOW_HEIGHT
        };
        Q_ENUM(Keys)

        static QString toString(SettingKey::Keys key)
        {
            QStringList enumToString;

            enumToString << "main/confirm-exit";
            enumToString << "main/close-to-tray";
            enumToString << "main/show-tray-icon";
            enumToString << "main/check-for-updates";
            enumToString << "main/update-channel";
            enumToString << "main/playback-requires-user-gesture";
            enumToString << "appearance/theme";
            enumToString << "appearance/accent";
            enumToString << "appearance/background";
            enumToString << "appearance/foreground";
            enumToString << "appearance/primary-background";
            enumToString << "appearance/primary-foreground";
            enumToString << "appearance/secondary-background";
            enumToString << "appearance/secondary-foreground";
            enumToString << "notifications/enabled";
            enumToString << "notifications/new-song";
            enumToString << "notifications/paused";
            enumToString << "notifications/resumed";
            enumToString << "shortcuts/play";
            enumToString << "shortcuts/next";
            enumToString << "shortcuts/previous";
            enumToString << "shortcuts/favorite";
            enumToString << "shortcuts/restore-window";
            enumToString << "shortcuts/reload";
            enumToString << "shortcuts/select-service";
            enumToString << "shortcuts/select-next-service";
            enumToString << "shortcuts/select-previous-service";
            enumToString << "shortcuts/notifications";
            enumToString << "shortcuts/listening-history";
            enumToString << "shortcuts/settings";
            enumToString << "shortcuts/create-plugin";
            enumToString << "shortcuts/report-issue";
            enumToString << "shortcuts/check-for-update";
            enumToString << "shortcuts/about";
            enumToString << "shortcuts/quit";
            enumToString << "privacy/enable-listening-history";
            enumToString << "privacy/listening-history-limit";
            enumToString << "privacy/user-agent";
            enumToString << "private/show-close-to-tray-message";
            enumToString << "private/current-service";
            enumToString << "private/window-width";
            enumToString << "private/window-height";

            return enumToString[static_cast<int>(key)];
        }
    };
}
